using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HanoiTowers
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
          
 allStands = new List<int>[] { Stand1plates, Stand2plates, Stand3plates };
            
            //   Stand2plates.Add(3);
        }

        List<int>[] allStands;
        List<int> Stand1plates = new List<int>();
        List<int> Stand2plates = new List<int>(); 
        List<int> Stand3plates = new List<int>();

        int plates = 4;
        int mySource=1,  myInter=2,myDest=3;
            
        int standWidth = 30;
        int plateHeight = 20;
        int TotalMoves;

        frmNext fnext = new frmNext();

        void solveTowers(int count, int source, int dest, int inter)
        {
            if (count == 1)
            {
                try
                {
                    MoveFromTo(source, dest);
                    TotalMoves++;
                    {
                        fnext.lblMove.Text = "Move from stand " + source.ToString() + " to stand " + dest.ToString();
                        fnext.lblMoves.Text = TotalMoves.ToString();
                        fnext.Location = new Point(this.Width / 2 - fnext.Width / 2, this.Height - 25);
                        fnext.ShowDialog();
                    }
                    label2.Text = "total moves: " + TotalMoves.ToString();

                }
                catch { }
            }

            else
            {
                solveTowers(count - 1, source, inter, dest);
                solveTowers(1, source, dest, inter);
                solveTowers(count - 1, inter, dest, source);
            }
        }

        private void MoveFromTo(int source, int dest)
        {
            int top = allStands[source-1][allStands[source-1].Count - 1];
            allStands[source - 1].Remove(top);
            allStands[dest-1].Add(top);

            RedrawPanels();

        } 
        void start()
        {
            TotalMoves = 0;

            for (int i = plates; i > 0; i--)
            {
                Stand1plates.Add(i);
            }
            RedrawPanels();
            solveTowers(plates, mySource, myDest, myInter);
        }
        private void RedrawPanels()
        {
            pnlDestination.Invalidate();
            pnlSource.Invalidate();
            pnlIntermediate.Invalidate();

        }


        private void button1_Click(object sender, EventArgs e)
        {
            start();
        }

        private void pnl_Paint(object sender, PaintEventArgs e)
        {
            Panel p = (Panel)sender;
            Graphics pnlGraphix = e.Graphics;
            pnlGraphix.Clear(Color.White);
            DrawTheStand(pnlGraphix, p);
            DrawPlates(pnlGraphix, p, p.TabIndex);
        }

        private void DrawTheStand(Graphics graphics, Panel p)
        {
            graphics.FillRectangle(new SolidBrush(Color.Gray), new Rectangle(p.Width / 2 - standWidth / 2, p.Width / 2 - standWidth / 2, standWidth, p.Height - 20));
        }
        private void DrawPlates(Graphics graphics, Panel p, int StandNo)
        {
            if (Stand1plates == null) return;
            Stand1plates.Sort();
            Stand1plates.Reverse();

            switch (StandNo)
            {
                case 1:
                    DrawStandPlates(graphics, Stand1plates, p); break;
                case 2:
                    DrawStandPlates(graphics, Stand2plates, p); break;
                case 3:
                    DrawStandPlates(graphics, Stand3plates, p); break;
            }


        }
        private void DrawStandPlates(Graphics graphics, List<int> plates, Panel p)
        {
            int i = 0;
            foreach (int plateNo in plates)
            {
                i++;
                graphics.FillEllipse(new SolidBrush(Color.Red), new Rectangle(p.Width / 2 - (plateNo * 30) / 2, p.Height - i * plateHeight, plateNo * 30, plateHeight));
                graphics.DrawString(plateNo.ToString(), new System.Drawing.Font("Tahoma", 12F, System.Drawing.FontStyle.Bold), Brushes.Black, new Rectangle(p.Width / 2-8 , p.Height - i * plateHeight, plateNo * 30, plateHeight));
            }
        }


        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            plates = Convert.ToInt32(numericUpDown1.Value);
            RedrawPanels();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://WWw.SourceCodes.ir");
        }


    } //ends Hanoi class

}